/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.guosen.bonusgroupbill.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.BladeUser;
import org.springblade.core.secure.utils.AuthUtil;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.modules.guosen.bonusgroupbill.entity.BonusGroupBill;
import org.springblade.modules.guosen.bonusgroupbill.vo.BonusGroupBillVO;
import org.springblade.modules.guosen.bonusgroupbill.wrapper.BonusGroupBillWrapper;
import org.springblade.modules.guosen.bonusgroupbill.service.IBonusGroupBillService;
import org.springblade.core.boot.ctrl.BladeController;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * 分润组收款账号 控制器
 *
 * @author BladeX
 * @since 2021-11-13
 */
@RestController
@AllArgsConstructor
@RequestMapping("cyzh-bonus-group-bill/bonusgroupbill")
@Api(value = "分润组收款账号", tags = "分润组收款账号接口")
public class BonusGroupBillController extends BladeController {

	private final IBonusGroupBillService bonusGroupBillService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入bonusGroupBill")
	public R<BonusGroupBillVO> detail(BonusGroupBill bonusGroupBill) {
		BonusGroupBill detail = bonusGroupBillService.getOne(Condition.getQueryWrapper(bonusGroupBill));
		return R.data(BonusGroupBillWrapper.build().entityVO(detail));
	}

	/**
	 * 分页 分润组收款账号
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入bonusGroupBill")
	public R<IPage<BonusGroupBillVO>> list(BonusGroupBill bonusGroupBill, Query query) {
		BladeUser bladeUser = AuthUtil.getUser();
		if(bladeUser.getRoleName().equals("财务管理") || bladeUser.getRoleName().equals("administrator")){
			Date date = bonusGroupBill.getBonusDate();
			String dateFormat = null;
			if(date != null){
				bonusGroupBill.setBonusDate(null);
				SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
				dateFormat = sdf.format(date);
			}
			LambdaQueryWrapper<BonusGroupBill> lambda = Condition.getQueryWrapper(bonusGroupBill).lambda();
			lambda.like(date != null, BonusGroupBill::getBonusDate, dateFormat);
			lambda.eq(bonusGroupBill.getBonusSceneId() != null, BonusGroupBill::getBonusSceneId, bonusGroupBill.getBonusSceneId());
			lambda.eq(bonusGroupBill.getBonusGroupId() != null, BonusGroupBill::getBonusGroupId, bonusGroupBill.getBonusGroupId());
			IPage<BonusGroupBill> pages = bonusGroupBillService.page(Condition.getPage(query), lambda);
			return R.data(BonusGroupBillWrapper.build().pageVO(pages));
		}else{
			return R.fail("无权限查看");
		}
	}


	/**
	 * 自定义分页 分润组收款账号
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入bonusGroupBill")
	public R<IPage<BonusGroupBillVO>> page(BonusGroupBillVO bonusGroupBill, Query query) {
		IPage<BonusGroupBillVO> pages = bonusGroupBillService.selectBonusGroupBillPage(Condition.getPage(query), bonusGroupBill);
		return R.data(pages);
	}

	/**
	 * 新增 分润组收款账号
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入bonusGroupBill")
	public R save(@Valid @RequestBody BonusGroupBill bonusGroupBill) {
		return R.status(bonusGroupBillService.save(bonusGroupBill));
	}

	/**
	 * 修改 分润组收款账号
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入bonusGroupBill")
	public R update(@Valid @RequestBody BonusGroupBill bonusGroupBill) {
		return R.status(bonusGroupBillService.updateById(bonusGroupBill));
	}

	/**
	 * 新增或修改 分润组收款账号
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入bonusGroupBill")
	public R submit(@Valid @RequestBody BonusGroupBill bonusGroupBill) {
		return R.status(bonusGroupBillService.saveOrUpdate(bonusGroupBill));
	}

	
	/**
	 * 删除 分润组收款账号
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(bonusGroupBillService.deleteLogic(Func.toLongList(ids)));
	}

	
}
